"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SequelizeServerModule = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _module = _interopRequireDefault(require("@lskjs/module"));
var _maskUriPassword = _interopRequireDefault(require("@lskjs/utils/maskUriPassword"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _sequelize = _interopRequireDefault(require("sequelize"));
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var SequelizeServerModule = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(SequelizeServerModule, _Module);
  var _super = _createSuper(SequelizeServerModule);
  function SequelizeServerModule() {
    var _this;
    (0, _classCallCheck2["default"])(this, SequelizeServerModule);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.config = {
      dialect: 'postgres',
      pool: {
        max: 5,
        min: 0,
        idle: 100000,
        acquire: 50000,
        evict: 50000,
        handleDisconnects: true
      }
    };
    _this.Sequelize = _sequelize["default"];
    return _this;
  }
  (0, _createClass2["default"])(SequelizeServerModule, [{
    key: "getOptions",
    value: function getOptions() {
      var _this2 = this;
      var options = (0, _omit["default"])(this.config, ['uri']);
      if (options.logging == null) options.logging = !!this.debug;
      if (options.logging) {
        options.logging = function (msg) {
          var msg2 = msg.split('Executing (default): ').reverse()[0];
          _this2.log.trace('[sql]', msg2);
        };
      }
      return options;
    }
  }, {
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var options;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _get2["default"])((0, _getPrototypeOf2["default"])(SequelizeServerModule.prototype), "init", this).call(this);
            case 2:
              if (this.config.uri) {
                _context.next = 6;
                break;
              }
              _context.next = 5;
              return this.log.warn('!uri', 'ignore module');
            case 5:
              return _context.abrupt("return");
            case 6:
              options = this.getOptions();
              this.client = new this.Sequelize(this.config.uri, options);
              _context.next = 10;
              return this.client.authenticate();
            case 10:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function init() {
        return _init.apply(this, arguments);
      }
      return init;
    }()
  }, {
    key: "run",
    value: function () {
      var _run = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (this.client) {
                _context2.next = 2;
                break;
              }
              return _context2.abrupt("return");
            case 2:
              _context2.next = 4;
              return this.client.sync();
            case 4:
              this.log.debug('[ready]', (0, _maskUriPassword["default"])(this.config.uri));
            case 5:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function run() {
        return _run.apply(this, arguments);
      }
      return run;
    }()
  }]);
  return SequelizeServerModule;
}(_module["default"]);
exports.SequelizeServerModule = SequelizeServerModule;
var _default = SequelizeServerModule;
exports["default"] = _default;
//# sourceMappingURL=SequelizeServerModule.js.map